/*
 * This file is part of decoding
 * Copyright 2012  Guillaume Quintin, INRIA
 * 
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License along
 * with this program; if not, write to the Free Software Foundation, Inc.,
 * 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA.
 */

/* structs */
#ifdef ll_upol_shift_fast_pc
#undef ll_upol_shift_fast_pc
#endif

#ifdef ll_upol_shift_car2_pc
#undef ll_upol_shift_car2_pc
#endif

#ifdef ll_dbpol_shift_fast_pc
#undef ll_dbpol_shift_fast_pc
#endif

#ifdef ll_dbpol_shift_car2_pc
#undef ll_dbpol_shift_car2_pc
#endif

#ifdef ll_vec_lili
#undef ll_vec_lili
#endif

#ifdef ll_upol_prod_tree
#undef ll_upol_prod_tree
#endif


/* labels */
#ifdef ll_dbpol_Xroots_rec_free_q
#undef ll_dbpol_Xroots_rec_free_q
#endif

#ifdef ll_dbpol_Xroots_rec_free_z0
#undef ll_dbpol_Xroots_rec_free_z0
#endif

#ifdef ll_koetter_single_free_stuff
#undef ll_koetter_single_free_stuff
#endif

#ifdef ll_koetter_multi_free_stuff
#undef ll_koetter_multi_free_stuff
#endif

#ifdef ll_upol_squarefree_free_disc
#undef ll_upol_squarefree_free_disc
#endif

#ifdef ll_upol_squarefree_free_buf
#undef ll_upol_squarefree_free_buf
#endif


/* low level functions */

/* lowlevels/array.c */
#ifdef ll_array_add
#undef ll_array_add
#endif

#ifdef ll_array_sub
#undef ll_array_sub
#endif

#ifdef ll_array_add_mul_by_cte
#undef ll_array_add_mul_by_cte
#endif


/* lowlevels/dbpol_eval_horner.c */
#ifdef ll_dbpol_eval_horner
#undef ll_dbpol_eval_horner
#endif

#ifdef ll_dbpol_eval_horner_upol
#undef ll_dbpol_eval_horner_upol
#endif


/* lowlevels/dbpol_mul_by_affine.c */
#ifdef ll_dbpol_mul_by_affine
#undef ll_dbpol_mul_by_affine
#endif


/* lowlevels/dbpol_mul_by_upol.c */
#ifdef ll_dbpol_mul_by_upolX
#undef ll_dbpol_mul_by_upolX
#endif

#ifdef ll_dbpol_mul_by_upolY
#undef ll_dbpol_mul_by_upolY
#endif


/* lowlevels/dbpol_mul_by_Y.c */
#ifdef ll_dbpol_mul_by_Y
#undef ll_dbpol_mul_by_Y
#endif

#ifdef ll_dbpol_mul_by_Yn
#undef ll_dbpol_mul_by_Yn
#endif


/* lowlevels/dbpol_mul.c */
#ifdef ll_dbpol_mul
#undef ll_dbpol_mul
#endif

#ifdef ll_dbpol_mul_naive
#undef ll_dbpol_mul_naive
#endif


/* lowlevels/dbpol_print.c */
#ifdef ll_dbpol_print_factorized
#undef ll_dbpol_print_factorized
#endif


/* lowlevels/dbpol_replace_X_by_XY.c */
#ifdef ll_dbpol_replace_X_by_XYn
#undef ll_dbpol_replace_X_by_XYn
#endif


/* lowlevels/dbpol_shift.c */
#ifdef ll_dbpol_shift
#undef ll_dbpol_shift
#endif

#ifdef ll_dbpol_shift_naive
#undef ll_dbpol_shift_naive
#endif


/* lowlevels/dbpol_shift_fast.c */
#ifdef ll_dbpol_shift_car2
#undef ll_dbpol_shift_car2
#endif

#ifdef ll_dbpol_shift_car22
#undef ll_dbpol_shift_car22
#endif

#ifdef ll_dbpol_shift_car2_finish
#undef ll_dbpol_shift_car2_finish
#endif

#ifdef ll_dbpol_shift_car2_prepare
#undef ll_dbpol_shift_car2_prepare
#endif

#ifdef ll_dbpol_shift_car2_rec
#undef ll_dbpol_shift_car2_rec
#endif

#ifdef ll_dbpol_shift_fast
#undef ll_dbpol_shift_fast
#endif

#ifdef ll_dbpol_shift_fast2
#undef ll_dbpol_shift_fast2
#endif

#ifdef ll_dbpol_shift_fast_finish
#undef ll_dbpol_shift_fast_finish
#endif

#ifdef ll_dbpol_shift_fast_prepare
#undef ll_dbpol_shift_fast_prepare
#endif

#ifdef ll_dbpol_shift_fast_rec
#undef ll_dbpol_shift_fast_rec
#endif


/* lowlevels/dbpol_shift_in_X.c */
#ifdef ll_dbpol_shift_in_X
#undef ll_dbpol_shift_in_X
#endif


/* lowlevels/dbpol_Xroots.c */
#ifdef ll_dbpol_Xroots
#undef ll_dbpol_Xroots
#endif

#ifdef ll_dbpol_Xroots_rec
#undef ll_dbpol_Xroots_rec
#endif


/* lowlevels/koetter.c */
#ifdef ll_koetter_multi
#undef ll_koetter_multi
#endif

#ifdef ll_koetter_single
#undef ll_koetter_single
#endif


/* lowlevels/koetter_shift.c */
#ifdef ll_koetter_shift_multi
#undef ll_koetter_shift_multi
#endif

#ifdef ll_koetter_shift_single
#undef ll_koetter_shift_single
#endif


/* lowlevels/koetter_shift_omp.c */
#ifdef ll_koetter_shift_omp_single
#undef ll_koetter_shift_omp_single
#endif

#ifdef ll_koetter_shift_omp_multi
#undef ll_koetter_shift_omp_multi
#endif


/* lowlevels/koetter_sudan.c */
#ifdef ll_koetter_sudan
#undef ll_koetter_sudan
#endif


/* lowlevels/koetter_sudan_omp.c */
#ifdef ll_koetter_sudan_omp
#undef ll_koetter_sudan_omp
#endif


/* lowlevels/linked_list_vec.c */
#ifdef ll_vec_lili_list_free
#undef ll_vec_lili_list_free
#endif

#ifdef ll_vec_lili_node_attach_after
#undef ll_vec_lili_node_attach_after
#endif

#ifdef ll_vec_lili_node_attach_before
#undef ll_vec_lili_node_attach_before
#endif

#ifdef ll_vec_lili_node_detach
#undef ll_vec_lili_node_detach
#endif

#ifdef ll_vec_lili_node_free
#undef ll_vec_lili_node_free
#endif

#ifdef ll_vec_lili_node_malloc
#undef ll_vec_lili_node_malloc
#endif

#ifdef ll_vec_lili_node_malloc_copy
#undef ll_vec_lili_node_malloc_copy
#endif

#ifdef ll_vec_lili_list_in
#undef ll_vec_lili_list_in
#endif


/* lowlevels/mat.c */
#ifdef ll_mat_copy
#undef ll_mat_copy
#endif

#ifdef ll_mat_free
#undef ll_mat_free
#endif

#ifdef ll_mat_malloc_init
#undef ll_mat_malloc_init
#endif

#ifdef ll_mat_malloc_random
#undef ll_mat_malloc_random
#endif

#ifdef ll_mat_transpose
#undef ll_mat_transpose
#endif

#ifdef ll_mat_print
#undef ll_mat_print
#endif

#ifdef ll_mat_put
#undef ll_mat_put
#endif


/* lowlevels/print.c */
#ifdef ll_print
#undef ll_print
#endif


/* lowlevels/upol_eucldiv.c */
#ifdef ll_upol_quo
#undef ll_upol_quo
#endif

#ifdef ll_upol_quo_naive
#undef ll_upol_quo_naive
#endif

#ifdef ll_upol_quorem
#undef ll_upol_quorem
#endif

#ifdef ll_upol_quorem_naive
#undef ll_upol_quorem_naive
#endif

#ifdef ll_upol_rem
#undef ll_upol_rem
#endif

#ifdef ll_upol_rem_naive
#undef ll_upol_rem_naive
#endif


/* lowlevels/upol_gcd.c */
#ifdef ll_upol_gcd
#undef ll_upol_gcd
#endif

#ifdef ll_upol_gcd_naive
#undef ll_upol_gcd_naive
#endif


/* lowlevels/upol_eval_horner.c */
#ifdef ll_upol_eval_horner
#undef ll_upol_eval_horner
#endif

#ifdef ll_upol_multi_eval_horner
#undef ll_upol_multi_eval_horner
#endif


/* lowlevels/upol_mul_by_affine.c */
#ifdef ll_upol_mul_by_affine
#undef ll_upol_mul_by_affine
#endif


/* lowlevels/upol_mul_by_X.c */
#ifdef ll_upol_mul_by_X
#undef ll_upol_mul_by_X
#endif

#ifdef ll_upol_mul_by_Xn
#undef ll_upol_mul_by_Xn
#endif


/* lowlevels/upol_mul.c */
#ifdef ll_upol_mul
#undef ll_upol_mul
#endif

#ifdef ll_upol_mul_naive
#undef ll_upol_mul_naive
#endif


/* lowlevels/upol_normalize.c */
#ifdef ll_upol_normalize
#undef ll_upol_normalize
#endif


/* lowlevels/upol_print.c */
#ifdef ll_upol_print
#undef ll_upol_print
#endif


/* lowlevels/upol_random.c */
#ifdef ll_upol_malloc_random
#undef ll_upol_malloc_random
#endif

#ifdef ll_upol_random
#undef ll_upol_random
#endif


/* lowlevels/upol_roots.c */
#ifdef ll_upol_roots
#undef ll_upol_roots
#endif


/* lowlevels/upol_shift.c */
#ifdef ll_upol_shift
#undef ll_upol_shift
#endif

#ifdef ll_upol_shift_naive
#undef ll_upol_shift_naive
#endif


/* lowlevels/upol_shift_fast.c */
#ifdef ll_upol_shift_car2
#undef ll_upol_shift_car2
#endif

#ifdef ll_upol_shift_car22
#undef ll_upol_shift_car22
#endif

#ifdef ll_upol_shift_car2_finish
#undef ll_upol_shift_car2_finish
#endif

#ifdef ll_upol_shift_car2_prepare
#undef ll_upol_shift_car2_prepare
#endif

#ifdef ll_upol_shift_car2_rec
#undef ll_upol_shift_car2_rec
#endif

#ifdef ll_upol_shift_fast
#undef ll_upol_shift_fast
#endif

#ifdef ll_upol_shift_fast2
#undef ll_upol_shift_fast2
#endif

#ifdef ll_upol_shift_fast_finish
#undef ll_upol_shift_fast_finish
#endif

#ifdef ll_upol_shift_fast_prepare
#undef ll_upol_shift_fast_prepare
#endif

#ifdef ll_upol_shift_fast_rec
#undef ll_upol_shift_fast_rec
#endif


/* lowlevels/upol_square.c */
#ifdef ll_upol_square
#undef ll_upol_square
#endif

#ifdef ll_upol_square_naive
#undef ll_upol_square_naive
#endif


/* lowlevels/upol_kronecker_modn_word.c */
#ifdef ll_upol_mul_kronecker_modn_word_encode
#undef ll_upol_mul_kronecker_modn_word_encode
#endif

#ifdef ll_upol_mul_kronecker_modn_word_decode
#undef ll_upol_mul_kronecker_modn_word_decode
#endif

#ifdef ll_upol_mul_kronecker_modn_word       
#undef ll_upol_mul_kronecker_modn_word       
#endif


/* lowlevels/utils.c */
#ifdef ll_die
#undef ll_die
#endif

#ifdef ll_put_word_into_mp_limb
#undef ll_put_word_into_mp_limb
#endif

#ifdef ll_get_word_from_mp_limb_1
#undef ll_get_word_from_mp_limb_1
#endif

#ifdef ll_get_word_from_mp_limb_n
#undef ll_get_word_from_mp_limb_n
#endif


/* lowlevels/vec.c */
#ifdef ll_vec_add
#undef ll_vec_add
#endif

#ifdef ll_vec_neg
#undef ll_vec_neg
#endif

#ifdef ll_vec_add_mul
#undef ll_vec_add_mul
#endif

#ifdef ll_vec_add_mul_by_cte
#undef ll_vec_add_mul_by_cte
#endif

#ifdef ll_vec_clear
#undef ll_vec_clear
#endif

#ifdef ll_vec_cmp
#undef ll_vec_cmp
#endif

#ifdef ll_vec_copy
#undef ll_vec_copy
#endif

#ifdef ll_vec_true_size
#undef ll_vec_true_size
#endif

#ifdef ll_vec_free
#undef ll_vec_free
#endif

#ifdef ll_vec_hamming_weight
#undef ll_vec_hamming_weight
#endif

#ifdef ll_vec_hamming_distance
#undef ll_vec_hamming_distance
#endif

#ifdef ll_vec_init
#undef ll_vec_init
#endif

#ifdef ll_vec_init_random
#undef ll_vec_init_random
#endif

#ifdef ll_vec_iszero
#undef ll_vec_iszero
#endif

#ifdef ll_vec_malloc_copy
#undef ll_vec_malloc_copy
#endif

#ifdef ll_vec_malloc_init
#undef ll_vec_malloc_init
#endif

#ifdef ll_vec_malloc_random
#undef ll_vec_malloc_random
#endif

#ifdef ll_vec_mul_by_cte
#undef ll_vec_mul_by_cte
#endif

#ifdef ll_vec_print
#undef ll_vec_print
#endif

#ifdef ll_vec_random
#undef ll_vec_random
#endif

#ifdef ll_vec_random_hamming_weight
#undef ll_vec_random_hamming_weight
#endif

#ifdef ll_vec_realloc
#undef ll_vec_realloc
#endif

#ifdef ll_vec_sub
#undef ll_vec_sub
#endif

#ifdef ll_vec_sub_mul
#undef ll_vec_sub_mul
#endif

#ifdef ll_vec_sub_sub
#undef ll_vec_sub_sub
#endif

#ifdef ll_vec_zero
#undef ll_vec_zero
#endif


/* lowlevels/upol_prod_affine.c */
#ifdef ll_upol_prod_affine
#undef ll_upol_prod_affine
#endif

#ifdef ll_upol_prod_affine_neg
#undef ll_upol_prod_affine_neg
#endif


/* lowlevels/dbpol_upol_map_XtoY.c */
#ifdef ll_dbpol_upol_map_XtoY
#undef ll_dbpol_upol_map_XtoY
#endif


/* lowlevels/binomial.c */
#ifdef ll_binomial
#undef ll_binomial
#endif


/* lowlevels/upol_discrepancy.c */
#ifdef ll_upol_discrepancy
#undef ll_upol_discrepancy
#endif


/* lowlevels/dbpol_discrepancy.c */
#ifdef ll_dbpol_discrepancy
#undef ll_dbpol_discrepancy
#endif


/* lowlevels/koetter_binomial.c */
#ifdef ll_koetter_binomial_single
#undef ll_koetter_binomial_single
#endif


/* lowlevels/upol_eval.c */
#ifdef ll_upol_eval
#undef ll_upol_eval
#endif

#ifdef ll_upol_multi_eval
#undef ll_upol_multi_eval
#endif


/* lowlevels/dbpol_eval.c */
#ifdef ll_dbpol_eval
#undef ll_dbpol_eval
#endif

#ifdef ll_dbpol_eval_upol
#undef ll_dbpol_eval_upol
#endif


/* lowlevels/upol_roots_fq.c */
#ifdef ll_upol_roots_fq
#undef ll_upol_roots_fq
#endif


/* lowlevels/upol_pow_mod.c */
#ifdef ll_upol_pow_mod
#undef ll_upol_pow_mod
#endif

#ifdef ll_upol_pow_mod_uma
#undef ll_upol_pow_mod_uma
#endif


/* lowlevels/upol_binpow_mod.c */
#ifdef ll_upol_binpow_mod
#undef ll_upol_binpow_mod
#endif


/* lowlevels/upol_derivative.c */
#ifdef ll_upol_derivative_naive
#undef ll_upol_derivative_naive
#endif

#ifdef ll_upol_derivative
#undef ll_upol_derivative
#endif


/* lowlevels/upol_eqdegsplit.c */
#ifdef ll_upol_trace_poly
#undef ll_upol_trace_poly
#endif

#ifdef ll_upol_cantor_zassenhaus
#undef ll_upol_cantor_zassenhaus
#endif

#ifdef ll_upol_eqdegsplit
#undef ll_upol_eqdegsplit
#endif


/* lowlevels/upol_eqdegfact.c */
#ifdef ll_upol_eqdegfact
#undef ll_upol_eqdegfact
#endif


/* decoding/lowlevels/upol.c */
#ifdef ll_upol_iszero
#undef ll_upol_iszero
#endif


/* decoding/lowlevels/upol_eea.c */
#ifdef ll_upol_eea_naive
#undef ll_upol_eea_naive
#endif

#ifdef ll_upol_eea
#undef ll_upol_eea
#endif


/* decoding/lowlevels/upol_partial_eea.c */
#ifdef ll_upol_partial_eea_naive
#undef ll_upol_partial_eea_naive
#endif

#ifdef ll_upol_partial_eea
#undef ll_upol_partial_eea
#endif


/* decoding/lowlevels/vec_prod.c */
#ifdef ll_vec_prod_naive
#undef ll_vec_prod_naive
#endif

#ifdef ll_vec_prod
#undef ll_vec_prod
#endif


/* decoding/lowlevels/upol_interpolation.c */
#ifdef ll_upol_interpolation_naive
#undef ll_upol_interpolation_naive
#endif

#ifdef ll_upol_interpolation
#undef ll_upol_interpolation
#endif


/* decoding/lowlevels/upol_mul_kronecker_char2_word.c */
#ifdef ll_put_word_into_unsigned_long
#undef ll_put_word_into_unsigned_long
#endif

#ifdef ll_get_word_from_unsigned_long_1
#undef ll_get_word_from_unsigned_long_1
#endif

#ifdef ll_upol_mul_kronecker_char2_word_encode
#undef ll_upol_mul_kronecker_char2_word_encode
#endif

#ifdef ll_upol_mul_kronecker_char2_word_decode
#undef ll_upol_mul_kronecker_char2_word_decode
#endif

#ifdef ll_upol_mul_kronecker_char2_word
#undef ll_upol_mul_kronecker_char2_word
#endif


/* decoding/lowlevels/upol_div_by_affine.c */
#ifdef ll_upol_div_by_affine
#undef ll_upol_div_by_affine
#endif

