/*
 * This file is part of decoding
 * Copyright 2012  Guillaume Quintin, INRIA
 * 
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License along
 * with this program; if not, write to the Free Software Foundation, Inc.,
 * 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA.
 */

#ifndef __GF2N_WORD_IRR
#define __GF2N_WORD_IRR

#define __IP2  ((1 << 2) ^ (1 << 1) ^ (1 << 0))
#define __IP3  ((1 << 3) ^ (1 << 1) ^ (1 << 0))
#define __IP4  ((1 << 4) ^ (1 << 1) ^ (1 << 0))
#define __IP5  ((1 << 5) ^ (1 << 2) ^ (1 << 0))
#define __IP6  ((1 << 6) ^ (1 << 1) ^ (1 << 0))
#define __IP7  ((1 << 7) ^ (1 << 1) ^ (1 << 0))
#define __IP8  ((1 << 8) ^ (1 << 4) ^ (1 << 3) ^ (1 << 1) ^ (1 << 0))
#define __IP9  ((1 << 9) ^ (1 << 1) ^ (1 << 0))
#define __IP10 ((1 << 10) ^ (1 << 3) ^ (1 << 0))
#define __IP11 ((1 << 11) ^ (1 << 2) ^ (1 << 0))
#define __IP12 ((1 << 12) ^ (1 << 3) ^ (1 << 0))
#define __IP13 ((1 << 13) ^ (1 << 4) ^ (1 << 3) ^ (1 << 1) ^ (1 << 0))
#define __IP14 ((1 << 14) ^ (1 << 5) ^ (1 << 0))
#define __IP15 ((1 << 15) ^ (1 << 1) ^ (1 << 0))
#define __IP16 ((1 << 16) ^ (1 << 5) ^ (1 << 3) ^ (1 << 1) ^ (1 << 0))

#define IRR_POLY(n) __C(__IP,n)

#endif
