/*
 * This file is part of decoding
 * Copyright 2013  Guillaume Quintin, INRIA
 * 
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License along
 * with this program; if not, write to the Free Software Foundation, Inc.,
 * 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA.
 */

/* structs */
#ifdef sugar_vec
#undef sugar_vec
#endif

#ifdef vec_ptr
#undef vec_ptr
#endif

#ifdef vec
#undef vec
#endif

#ifdef sugar_rs_code
#undef sugar_rs_code
#endif

#ifdef rs_code_ptr
#undef rs_code_ptr
#endif

#ifdef rs_code
#undef rs_code
#endif


/* labels */

/* sugar/vec.c */
#ifdef vec_init
#undef vec_init
#endif

#ifdef vec_inits
#undef vec_inits
#endif

#ifdef vec_clear
#undef vec_clear
#endif

#ifdef vec_clears
#undef vec_clears
#endif

#ifdef vec_adjust_size
#undef vec_adjust_size
#endif

#ifdef vec_zero
#undef vec_zero
#endif

#ifdef vec_append
#undef vec_append
#endif

#ifdef vec_random
#undef vec_random
#endif

#ifdef vec_random_hamming_weight
#undef vec_random_hamming_weight
#endif

#ifdef vec_add
#undef vec_add
#endif

#ifdef vec_sub
#undef vec_sub
#endif

#ifdef vec_mul_by_cte
#undef vec_mul_by_cte
#endif

#ifdef vec_set_coeff
#undef vec_set_coeff
#endif

#ifdef vec_get_coeff
#undef vec_get_coeff
#endif

#ifdef vec_get_len
#undef vec_get_len
#endif

#ifdef vec_hamming_weight
#undef vec_hamming_weight
#endif

#ifdef vec_hamming_distance
#undef vec_hamming_distance
#endif

#ifdef vec_copy
#undef vec_copy
#endif

#ifdef vec_cmp
#undef vec_cmp
#endif

#ifdef vec_ptr_clear
#undef vec_ptr_clear
#endif

#ifdef vec_print
#undef vec_print
#endif


/* sugar/rs.c */
#ifdef rs_code_init
#undef rs_code_init
#endif

#ifdef rs_code_init_with_support
#undef rs_code_init_with_support
#endif

#ifdef rs_code_clear
#undef rs_code_clear
#endif

#ifdef rs_code_random_codeword
#undef rs_code_random_codeword
#endif

#ifdef rs_code_sudan_koetter
#undef rs_code_sudan_koetter
#endif

#ifdef rs_code_guruswami_sudan_koetter
#undef rs_code_guruswami_sudan_koetter
#endif

#ifdef rs_code_gao
#undef rs_code_gao
#endif


/* sugar/print.c */
#ifdef decoding_printf
#undef decoding_printf
#endif

