/*
 * This file is part of decoding
 * Copyright 2013  Guillaume Quintin, INRIA
 * 
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License along
 * with this program; if not, write to the Free Software Foundation, Inc.,
 * 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA.
 */

#include <decoding/decoding.h>

#define RING_NAME F
#include <decoding/rings/GF5.c>
#include <decoding/algos.c>

using namespace decoding;

int main(void) {
  F a;
  ll_random_seed(time(NULL));
  F_ring_init();
  F_random(a);
  F_ll_print(stdout,"%e\n",a);
  F_ring_clear();
  return 0;
}

