##
This file is part of decoding
Copyright (C) 2012-2013  Guillaume Quintin

This program is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 2 of the License, or
(at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License along
with this program; if not, write to the Free Software Foundation, Inc.,
51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA.
##

==NAME==

sizeof - print the size of some basic C types

==SYNOPSIS==

`sizeof` [`-v` | [`-b`] `type`]

==DESCRIPTION==

Print the size in bytes of some basic C types.

> `-v`
  Print the version of sizeof.

> `-b`
  Print the size in bits of the type.

> `type`
  The C type `type` of which you want to know the size.
  Possible values for `type` are signed or unsigned `char`,
  `short`, `int`, `long`, `float`, `double`, `void*`, `char*`,
  `short*`, `int*`, `long*`, `float*` and `double*`.

==AUTHOR==

Written by Guillaume Quintin (quintin@lix.polytechnique.fr).

